package model.questionnaire;

import com.github.cliftonlabs.json_simple.JsonObject;
import com.github.cliftonlabs.json_simple.Jsonable;
import model.personnality.Trait;

import java.io.IOException;
import java.io.StringWriter;
import java.io.Writer;
import java.nio.charset.StandardCharsets;
import java.util.UUID;

public class Answer implements Jsonable {

    private UUID    fUUID;
    private float   fWeight;
    private Trait   fTrait;
    private String  fDescription;


    public Answer(String iDescription, Trait iTrait, float iWeight)
    {
        fUUID           = UUID.randomUUID();    // I feel like I should check this is truly unique among answers
        fWeight         = iWeight;
        fTrait          = iTrait;
        fDescription    = iDescription;
    }

    public Trait getTrait() { return fTrait; }
    public float getWeight() { return fWeight; }


    @Override
    public String toJson() {
        final StringWriter writable = new StringWriter();
        try{
            this.toJson(writable);
        }catch(final IOException caught)
        {
            caught.printStackTrace();
        }
        return writable.toString();
    }

    @Override
    public void toJson(Writer writable) throws IOException {
        final JsonObject vResult = new JsonObject();
        vResult.put("description", fDescription);
        vResult.put("id", fUUID.toString());
        writable.write(new String(vResult.toJson().getBytes(StandardCharsets.UTF_8), StandardCharsets.UTF_8));
    }
}
