package model.questionnaire;

import com.github.cliftonlabs.json_simple.JsonObject;
import com.github.cliftonlabs.json_simple.Jsonable;

import java.io.IOException;
import java.io.StringWriter;
import java.io.Writer;
import java.nio.charset.StandardCharsets;
import java.util.List;

public class Question implements Jsonable {

    private List<Answer> fAnswers;
    private String fName;

    public Question(String iName, List<Answer> iAnswers)
    {
        fName = iName;
        fAnswers = iAnswers;
    }

    @Override
    public String toJson() {
        final StringWriter writable = new StringWriter();
        try{
            this.toJson(writable);
        }catch(final IOException caught)
        {
            caught.printStackTrace();
        }
        return writable.toString();
    }

    @Override
    public void toJson(Writer writable) throws IOException {
        JsonObject vResult = new JsonObject();
        vResult.put("name", fName);
        vResult.put("answers", fAnswers);
        writable.write(new String(vResult.toJson().getBytes(StandardCharsets.UTF_8), StandardCharsets.UTF_8));
    }
}
