import React from 'react';
import url from '../server';

function Question(props){
    let question = props.questions[props.index];
    const [selectedAnswer, onSelectAnswer] = React.useState(question.answer);
    let question_answers = [];

    //-------------------------------
    // Build question form
    //-------------------------------
    question.answers.forEach(answer => {
        let dom_id = "answer"+answer.id
        question_answers.push(
            <div key={dom_id}>
                <input name="answer" id={dom_id} type="radio" value={answer.id} defaultChecked={answer.id === selectedAnswer}/>
                <label htmlFor={dom_id}>{answer.description}</label>
            </div>
        );
    });
    
    return (
    <div>
        <div> {question.name} </div>
        <div onChange={(value) => onSelectAnswer(value.target.value)}>
        {question_answers}
        </div>
        <div
            onClick={() => {
                if(props.index === props.questions.length - 1)
                {
                    question.answer = selectedAnswer;
                }
                else
                {
                    question.answer = selectedAnswer;
                    props.moveToQuestion(props.index + 1);
                }
            }}>
                {props.index < props.questions.length -1 ? "Validate" : "Get Result" }
        </div>
    </div>
    );
}

export default Question;