import React from 'react';
import url from '../server';
import Question from './question';

function Questionnaire(){
    const [currentIndex, onMoveToIndex] = React.useState(0);
    const [questionnaireDataFetched, onQuestionnaireDataFetched] = React.useState(null);

    //-------------------------------
    // Fetch questionnaire
    //-------------------------------
    if(null === questionnaireDataFetched)
    {
        fetch(url+"/questionnaire")
            .then(response => response.json())
            .then(result => {
                onQuestionnaireDataFetched(result);
            })
            .catch( e => {
                console.log(e);
            })
    }

    return (<React.Fragment>
        {
            null === questionnaireDataFetched ?
            <div> Questionnaire is loading </div>
            :
            <Question
                key={"question_"+currentIndex}   //force throw away to ease radio buttons management 
                questions={questionnaireDataFetched.questions}
                index={currentIndex}
                moveToQuestion={onMoveToIndex}/>
        }
        <div>
        {
            currentIndex > 0 ? <div onClick={() => onMoveToIndex(currentIndex-1)}>Previous Question</div> : ''  
        }
        {
            null != questionnaireDataFetched && currentIndex < questionnaireDataFetched.questions.length - 1 && 'answer' in questionnaireDataFetched.questions[currentIndex] && 
            <div onClick={() => onMoveToIndex(currentIndex+1)}>Next Question</div>
        }
        </div>
        </React.Fragment>
    )
}

export default Questionnaire;